<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_PackageItinerary ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_PackageItinerary extends AbstractStructArrayBase
{
    /**
     * The Itinerary
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_PackageItinerary[]
     */
    public $Itinerary;
    /**
     * Constructor method for ArrayOfJP_PackageItinerary
     * @uses ArrayOfJP_PackageItinerary::setItinerary()
     * @param \StructType\JP_PackageItinerary[] $itinerary
     */
    public function __construct(array $itinerary = array())
    {
        $this
            ->setItinerary($itinerary);
    }
    /**
     * Get Itinerary value
     * @return \StructType\JP_PackageItinerary[]|null
     */
    public function getItinerary()
    {
        return $this->Itinerary;
    }
    /**
     * This method is responsible for validating the values passed to the setItinerary method
     * This method is willingly generated in order to preserve the one-line inline validation within the setItinerary method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateItineraryForArrayConstraintsFromSetItinerary(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_PackageItineraryItineraryItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_PackageItineraryItineraryItem instanceof \StructType\JP_PackageItinerary) {
                $invalidValues[] = is_object($arrayOfJP_PackageItineraryItineraryItem) ? get_class($arrayOfJP_PackageItineraryItineraryItem) : sprintf('%s(%s)', gettype($arrayOfJP_PackageItineraryItineraryItem), var_export($arrayOfJP_PackageItineraryItineraryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Itinerary property can only contain items of type \StructType\JP_PackageItinerary, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Itinerary value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_PackageItinerary[] $itinerary
     * @return \ArrayType\ArrayOfJP_PackageItinerary
     */
    public function setItinerary(array $itinerary = array())
    {
        // validation for constraint: array
        if ('' !== ($itineraryArrayErrorMessage = self::validateItineraryForArrayConstraintsFromSetItinerary($itinerary))) {
            throw new \InvalidArgumentException($itineraryArrayErrorMessage, __LINE__);
        }
        $this->Itinerary = $itinerary;
        return $this;
    }
    /**
     * Add item to Itinerary value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_PackageItinerary $item
     * @return \ArrayType\ArrayOfJP_PackageItinerary
     */
    public function addToItinerary(\StructType\JP_PackageItinerary $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_PackageItinerary) {
            throw new \InvalidArgumentException(sprintf('The Itinerary property can only contain items of type \StructType\JP_PackageItinerary, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Itinerary[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_PackageItinerary|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_PackageItinerary|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_PackageItinerary|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_PackageItinerary|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_PackageItinerary|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Itinerary
     */
    public function getAttributeName()
    {
        return 'Itinerary';
    }
}
